package com.jcg.assignment;

import com.jcg.assignment.util.Student;
import com.jcg.assignment.util.StudentDto;

import java.util.List;
import java.util.stream.Collectors;

// map(...) method syntax
// <R> Stream<R>	map(Function<? super T,? extends R>mapper)

public class Java8MapExample {

    private static void prepareStringList() {
        // Using map function to convert Stream<Student> to Stream<String>
        final List<String> studentNames = Student.createStudents()
                .stream()
                .map(Student::getName)
                .collect(Collectors.toList());

        studentNames.forEach(System.out::println);
    }

    private static void convertToStudentDtoList() {
        // Using map function to convert Stream<Student> to Stream<StudentDto>
        final List<StudentDto> studentDtos = Student.createStudents()
                .stream()
                .map(student -> new StudentDto(student.getId(), student.getName(), student.getCgpa()))
                .collect(Collectors.toList());

        studentDtos.forEach(studentDto -> System.out.println(studentDto.toString()));
    }

    public static void main(String[] args) {
        prepareStringList();
        System.out.println("----------");
        convertToStudentDtoList();
    }
}
